

#ifndef  __ALARMCONTROL_H__
#define  __ALARMCONTROL_H__


#include <cstdint>


extern "C++" {
	namespace avelino {
		using namespace std;

		class AlarmControlIO {
			public:
				virtual bool getAlarm() = 0;
				virtual void startTrigSound() = 0;
				virtual void stopTrigSound() = 0;
				virtual void startTrigSilence() = 0;
				virtual void stopTrigSilence() = 0;
		};

		class AlarmControl {
			protected:
				AlarmControlIO &io;
				enum class Status { RESET, TRIG_SILENCE, WAIT_SILENCE, WAIT_1, TRIG_SOUND, WAIT_SOUND, WAIT_0 };
				Status status;
				uint32_t counter;
				static const uint32_t N_SILENCE = 4;
				static const uint32_t N_SOUND = 4;
			public:
				AlarmControl(AlarmControlIO &alarmControlIO) : io(alarmControlIO), status(Status::RESET) { };
				void run();
		};
	}
}


#endif  // __ALARMCONTROL_H__
