

#include "AlarmControl.H"


using namespace std;
using namespace avelino;


void AlarmControl::run() {
	Status localStatus = this->status;
	do {
		this->status = localStatus;
		if (localStatus == Status::RESET) {
			this->io.stopTrigSound();
			this->io.stopTrigSilence();
			localStatus = Status::TRIG_SILENCE;
		}
		else if (localStatus == Status::TRIG_SILENCE) {
			this->io.startTrigSilence();
			this->counter = N_SILENCE;
			localStatus = Status::WAIT_SILENCE;
		}
		else if (localStatus == Status::WAIT_SILENCE) {
			this->counter--;
			if (this->counter == 0) {
				this->io.stopTrigSilence();
				localStatus = Status::WAIT_1;
			}
		}
		else if (localStatus == Status::WAIT_1) {
			if (this->io.getAlarm())
				localStatus = Status::TRIG_SOUND;
		}
		else if (localStatus == Status::TRIG_SOUND) {
			this->io.startTrigSound();
			this->counter = N_SOUND;
			localStatus = Status::WAIT_SOUND;
		}
		else if (localStatus == Status::WAIT_SOUND) {
			this->counter--;
			if (this->counter == 0) {
				this->io.stopTrigSound();
				localStatus = Status::WAIT_0;
			}
		}
		else if (localStatus == Status::WAIT_0) {
			if (!this->io.getAlarm())
				localStatus = Status::TRIG_SILENCE;
		}
	} while (localStatus != this->status);
}

